<?php
/**
 * PluginActiveTransition
 * 
 * This class has been auto-generated by the Doctrine ORM Framework
 * 
 * @package    ##PACKAGE##
 * @subpackage ##SUBPACKAGE##
 * @author     ##NAME## <##EMAIL##>
 * @version    SVN: $Id: Builder.php 6820 2009-11-30 17:27:49Z jwage $
 */
abstract class PluginActiveTransition extends BaseActiveTransition
{
  /*
   * 取得するテーブル名とカラムの対応
   */
  static public $seekingColumns = array(
    'Member'                  => array('id','invite_member_id','is_login_rejected','created_at','updated_at','is_active'),
    'MemberRelationship'      => array('id','member_id_to','member_id_from','is_friend','is_friend_pre','is_access_block','created_at','updated_at'),
    'Diary'                   => array('id','member_id','public_flag','created_at','updated_at'),
    'DiaryComment'            => array('id','diary_id','member_id','number','created_at','updated_at'),
    'Community'               => array('id','created_at','updated_at'),
    'CommunityMember'         => array('id','community_id','member_id','is_pre','is_receive_mail_pc','is_receive_mail_mobile','created_at','updated_at'),
//    'CommunityMemberPosition' => array('id','community_id','member_id','community_member_id','name','created_at','updated_at'),
    'CommunityTopic'          => array('id','community_id','member_id','topic_updated_at','created_at','updated_at'),
    'CommunityTopicComment'   => array('id','community_topic_id','member_id','number','created_at','updated_at'),
  );

    static public $statuses = array(
         0 => 'failed identify',               // 識別ID発行時に何らかの理由で中断
         1 => 'failed connecting on identify', // 識別ID発行時に接続エラー
         2 => '404 on identify',               // 識別ID発行時に404 Not Found
         3 => 'invalid request on identify',   // 識別ID発行申請時のパラメータが不正
         9 => 'unknown error on identify',     // 識別ID発行時に規定外のレスポンス
        10 => 'failed sending',                // データ送信時に何らかの理由で中断
        11 => 'failed connecting on sending',  // データ送信時に接続エラー
        12 => '404 on sending',                // データ送信時に404 Not Found
        13 => 'invalid request on sending',    // データ送信時にパラメータ不正
        14 => 'unknown identity',              // 送信時に識別IDが見つからなかった
        15 => 'internal server error',         // サーバ内部エラー
        18 => 'still on progress',             // 前回のデータが処理中
        19 => 'unknown error on sending',      // データ送信時に規定外のレスポンス
        20 => 'succeeded uploading',           // 送信成功
        30 => 'under construction',            // アクティブ遷移図作成中
        31 => 'failed connecting on checking', // チェック時に接続エラー
        32 => '404 on checking',               // チェック時に404 Not Found
        33 => 'invalid request on checking',   // チェック時に不正なリクエスト
        39 => 'unknown error on checking',     // 更新チェック時に規定外のレスポンス
        40 => 'unknown applicant',             // 申請履歴が見つからない
        50 => 'construction failed',           // 何らかの理由で作成に失敗
        60 => 'completed',                     // 作成完了
        );
    static public $undefined = 'undefined status';

  public function getStatusString() {
    $status = $this->getStatus();
    $status_string = array_key_exists($status, self::$statuses) ? self::$statuses[$status] : self::$undefined;
    return __($status_string);
  }

  static public function getProperty($email_string) {
    $dom = new DomDocument('1.0');
    $dom->encoding = "UTF-8";
    $dom->formatOutput = true;
    $dataroot = $dom->appendChild($dom->createElement('dataroot'));
    $version = $dataroot->appendChild($dom->createElement('data_version'));
    $version->appendChild($dom->createTextNode('1.0'));
    $email = $dataroot->appendChild($dom->createElement('email_address'));
    $email->appendChild($dom->createTextNode($email_string));
    $domain = $dataroot->appendChild($dom->createElement('domain'));
    $url = sfContext::getInstance()->getRequest()->getUriPrefix() .
      sfContext::getInstance()->getRequest()->getRelativeUrlRoot();
    $domain->appendChild($dom->createTextNode($url));
    return $dom->saveXML();
  }

    /**
     *  受け取った問い合わせ結果からデータを取り出す
     */
    static public function retrieveData($query) {
        return $query->execute(array(), Doctrine::HYDRATE_ARRAY);
    }
  
    /**
     * カラム名配列とデータからcsv形式のデータを作成し，返す
     */
    static public function getCsvFromResultSet($tableName, &$rs){
        $columns = self::$seekingColumns[$tableName];
        $data = implode(',', $columns) . ",\n"; // タイトル部分
        foreach ($rs as $row) {
            foreach ($columns as $column) {
                // データ部分
                if (array_key_exists($column, $row)) {
                    $data .= $row[$column];
                }
                $data .= ',';
            }
            $data .= "\n";
        }
        
        return $data;
    }

    /**
     * 指定されたテーブルに対して指定した範囲を取得するためのクエリを返す．
     *
     * $tableName : テーブル名
     * $offset    : 開始位置
     * $limit     : 取得数
     * return     : 指定されたテーブル，指定された範囲のデータを取得するクエリ
     */
    static public function createQuery($tableName, $offset, $limit) {
        return Doctrine::getTable($tableName)
          ->createQuery()
            ->offset($offset)
              ->limit($limit);
    }

    /**
     * SNSのデータをサーバにPOSTする．
     *
     * host     : 送信先ホスト
     * filePath : 送信するデータのパス
     * id       : 何番目のファイルかを知らせる．1から始まり，最後のファイルのみ-1．
     */
    static public function postData($host, $filePath, $email, $id) {
        require_once "HTTP/Client.php";
        $params = array(
            'Content-Type' => "multipart/form-data",
            'userfile'     => $filePath,
            'hash'         => ActiveTransitionHashTable::getHash(),
            'email'        => $email,
            'host'         => implode('/', array_slice(explode('/', sfContext::getInstance()->getRequest()->getUri()), 2, -3)),
            'id'           => $id,
        );
        $fileData = array(array('userfile', $filePath, 'application/octet-stream'));
        $client =& new HTTP_Client();
        $client->post('https://' . $host, $params, false, $fileData);
        $response = $client->currentResponse();
        if ($response === null) { // httpsで接続出来なかった場合
            $client->post('http://' . $host, $params, false, $fileData);
            $response = $client->currentResponse();
        }
        return $response;
    }
}
