<?php
/**
 * SNS固有の識別用文字列を管理する．
 */
class PluginActiveTransitionHashTable extends Doctrine_Table
{
    /*
     * DBに格納された識別用文字列を取得する．
     * return 既に存在する場合は識別用IDを返す．
     */
    static public function getHash() {
        // DBから文字列を取得
        $row = Doctrine::getTable('ActiveTransitionHash')
          ->createQuery('a')
            ->fetchOne();
        return $row ? $row->hash : NULL;
    }

    /*
     * 識別用文字列がまだセットされていない場合に限り，
     * DBに識別用文字列をセットする．
     */
    static public function setHash($hash) {
        if (self::getHash()) {
            // 既に識別IDが存在
            return;
        }
        // 識別IDを設定
        $record = new ActiveTransitionHash();
        $record->hash = $hash;
        $record->save();
    }
}
