<?php
/**
 * テーブル操作
 */
class PluginActiveTransitionTable extends Doctrine_Table
{
    /**
     * 最新のログの状態を更新
     */
    static public function updateStatus($status) {
        Doctrine_Query::create()
          ->update('ActiveTransition a')
            ->set('a.status', '?', $status)
              ->orderBy('a.id DESC')
                ->limit(1)
                  ->execute();
    }
    
    /**
     * 作成中のログのうち，最新のものを取得
     */
    static public function getUnderConstruction() {
        return Doctrine::getTable('ActiveTransition')
          ->createQuery('a')
            ->where('a.status >= 20')
              ->andWhere('a.status < 40')
                ->orderBy('a.id DESC')
                  ->fetchOne();
    }
}
